const AsksuiteProcessingNatural = require('../AsksuiteProcessingNatural');
const MockGenerator = require('../mocks/MockGenerator');

describe('Asksuite Processing Natural testing...', () => {
    it('Should return DialogFlow intent', async () => {
        const data = MockGenerator.generateIncoming('Oi');
        const asksuiteProcessingNatural = new AsksuiteProcessingNatural();

        const result = await asksuiteProcessingNatural.findIntent(data);
        expect(result.intent).toBe('saudacao');
        expect(result.resolver).toBe('DIALOG_FLOW');
    });

    it('Should return KeyMatcher intent', async () => {
        const data = MockGenerator.generateIncoming('Vale lembrar que a nossa estadia é pelo convênio com SBTUR');
        const asksuiteProcessingNatural = new AsksuiteProcessingNatural();

        const result = await asksuiteProcessingNatural.findIntent(data);
        expect(result.intent).toBe('convenio_sbtur');
        expect(result.resolver).toBe('KEY_MATCHER');
    });

    it('Should return RASA intent', async () => {
        const data = MockGenerator.generateIncoming('quero passar no teste do rasa');
        data.companyId = 'teste_rasa_core';
        const asksuiteProcessingNatural = new AsksuiteProcessingNatural();

        const result = await asksuiteProcessingNatural.findIntent(data);
        expect(result.resolver).toBe('RASA');
        expect(result.intent).toBe('asksuite_rasa_teste_resort');

    });

    it('Should return naoentendi', async () => {
        const data = MockGenerator.generateIncoming('HI USHAKJHJHZXNC HDSAHF SANFDJKIUHQWDFJAS NKJ');
        const asksuiteProcessingNatural = new AsksuiteProcessingNatural();

        const result = await asksuiteProcessingNatural.findIntent(data);
        expect(result.intent).toBe('naoentendi');
    });
});
